VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Begin VB.Form frmMain 
   BackColor       =   &H00E0E0E0&
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Chian MDB utility"
   ClientHeight    =   3345
   ClientLeft      =   45
   ClientTop       =   615
   ClientWidth     =   6270
   Icon            =   "frmMain.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3345
   ScaleWidth      =   6270
   StartUpPosition =   2  'CenterScreen
   Begin MSComctlLib.Toolbar Toolbar1 
      Align           =   1  'Align Top
      Height          =   360
      Left            =   0
      TabIndex        =   1
      Top             =   0
      Width           =   6270
      _ExtentX        =   11060
      _ExtentY        =   635
      ButtonWidth     =   609
      ButtonHeight    =   582
      Appearance      =   1
      Style           =   1
      ImageList       =   "imgToolbar"
      _Version        =   393216
      BeginProperty Buttons {66833FE8-8583-11D1-B16A-00C0F0283628} 
         NumButtons      =   5
         BeginProperty Button1 {66833FEA-8583-11D1-B16A-00C0F0283628} 
            Style           =   3
         EndProperty
         BeginProperty Button2 {66833FEA-8583-11D1-B16A-00C0F0283628} 
            Key             =   "compact"
            Object.ToolTipText     =   "Compact MDB file"
            ImageIndex      =   1
         EndProperty
         BeginProperty Button3 {66833FEA-8583-11D1-B16A-00C0F0283628} 
            Style           =   3
         EndProperty
         BeginProperty Button4 {66833FEA-8583-11D1-B16A-00C0F0283628} 
            Key             =   "repair"
            Object.ToolTipText     =   "Repair MDB file"
            ImageIndex      =   2
         EndProperty
         BeginProperty Button5 {66833FEA-8583-11D1-B16A-00C0F0283628} 
            Style           =   3
         EndProperty
      EndProperty
   End
   Begin MSComctlLib.ImageList imgToolbar 
      Left            =   1920
      Top             =   600
      _ExtentX        =   1005
      _ExtentY        =   1005
      BackColor       =   -2147483643
      ImageWidth      =   16
      ImageHeight     =   16
      MaskColor       =   12632256
      _Version        =   393216
      BeginProperty Images {2C247F25-8591-11D1-B16A-00C0F0283628} 
         NumListImages   =   2
         BeginProperty ListImage1 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "frmMain.frx":0442
            Key             =   ""
         EndProperty
         BeginProperty ListImage2 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "frmMain.frx":055E
            Key             =   ""
         EndProperty
      EndProperty
   End
   Begin MSComctlLib.StatusBar StatusBar1 
      Align           =   2  'Align Bottom
      Height          =   255
      Left            =   0
      TabIndex        =   0
      Top             =   3090
      Width           =   6270
      _ExtentX        =   11060
      _ExtentY        =   450
      _Version        =   393216
      BeginProperty Panels {8E3867A5-8586-11D1-B16A-00C0F0283628} 
         NumPanels       =   2
         BeginProperty Panel1 {8E3867AB-8586-11D1-B16A-00C0F0283628} 
            AutoSize        =   1
            Bevel           =   0
            Object.Width           =   8096
         EndProperty
         BeginProperty Panel2 {8E3867AB-8586-11D1-B16A-00C0F0283628} 
            Object.Width           =   2893
            MinWidth        =   2893
            Object.ToolTipText     =   "Date program started"
         EndProperty
      EndProperty
   End
   Begin VB.Label lblGuide 
      BackStyle       =   0  'Transparent
      Height          =   1215
      Left            =   480
      TabIndex        =   2
      Top             =   720
      Width           =   5415
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileCompact 
         Caption         =   "Compact MDB database..."
         Shortcut        =   {F5}
      End
      Begin VB.Menu mnuFileRepair 
         Caption         =   "&Repair MDB database..."
         Shortcut        =   ^R
      End
      Begin VB.Menu mnuFileSep1 
         Caption         =   "-"
      End
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
         Shortcut        =   ^Q
      End
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub Form_Load()
    On Error GoTo localErr
    lblGuide.Caption = "WARNING: Ensure no other user or software application is running the MDB file you intend to compact or repair using this utility program." & vbCrLf
    lblGuide.Caption = lblGuide.Caption & "You must compact an MDB file to another file name." & vbCrLf
    lblGuide.Caption = lblGuide & "When you've have compacted this file, first delete the original file name "
    lblGuide.Caption = lblGuide.Caption & "and then rename the new compacted file name back to the original database file name."
    StatusBar1.Panels(2).Text = Format(Date, "dd mmmm yyyy")
    Exit Sub

localErr:
    MsgBox Err.Description, vbCritical, Err.Number
End Sub

Private Sub Form_Unload(Cancel As Integer)
    On Error GoTo localErr
    End
    Exit Sub

localErr:
    MsgBox Err.Description, vbCritical, Err.Number
End Sub

Private Sub mnuFileCompact_Click()
    On Error GoTo localErr
    Dim ret&
    Dim cDLG As cFileDlg
    Dim mdbtocomp$
    Dim mdbcomp$
    
    Set cDLG = New cFileDlg
    With cDLG
        .InitDirectory = App.Path & "\..\"
        .OwnerHwnd = Me.hWnd
        .DefaultExt = True
        .DlgTitle = "Select Microsoft Access Database to compact"
        .Filter = "Microsoft Access MDB's (*.mdb)|*.mdb"
    End With
    ret& = cDLG.VBGetOpenFileName(mdbtocomp$)
    If ret& = False Then Exit Sub
    '
    mdbcomp$ = "filepaths1.mdb"
    With cDLG
        .InitDirectory = App.Path & "\..\"
        .OwnerHwnd = Me.hWnd
        .DefaultExt = True
        .DlgTitle = "Select Microsoft Access Database to compact too"
        .Filter = "Microsoft Access MDB's (*.mdb)|*.mdb"
    End With
    ret& = cDLG.VBGetSaveFileName(mdbcomp$)
    If ret& = False Then Exit Sub
    
    If mdbtocomp$ <> vbNullString _
    And mdbcomp$ <> vbNullString Then
        DBEngine.CompactDatabase mdbtocomp$, mdbcomp$, dbLangGeneral, dbEncrypt
        StatusBar1.Panels(1).Text = StripPath(mdbcomp$) & " compacted."
    End If
    Exit Sub

localErr:
    MsgBox Err.Number & ": " & Err.Description, vbCritical, Err.Source
End Sub

Private Sub mnuFileExit_Click()
    On Error GoTo localErr
    Unload Me
    Exit Sub

localErr:
    MsgBox Err.Description, vbCritical, Err.Number
End Sub

Private Sub mnuFileRepair_Click()
    'WARNING: you can't run this procedure
    'from a module within an Microsoft Access Database
    On Error GoTo localErr
    Dim errLoop As Error
    Dim ret&
    Dim cDLG As cFileDlg
    Dim mdbfile$
    
    Set cDLG = New cFileDlg
    With cDLG
        .InitDirectory = App.Path & "\..\"
        .OwnerHwnd = Me.hWnd
        .DefaultExt = True
        .DlgTitle = "Select Microsoft Access Database to repair"
        .Filter = "Microsoft Access MDB's (*.mdb)|*.mdb"
    End With
    ret& = cDLG.VBGetOpenFileName(mdbfile$)
    If ret& = False Then Exit Sub
    If mdbfile$ <> vbNullString Then
        DBEngine.RepairDatabase mdbfile$
        On Error GoTo 0
        StatusBar1.Panels(1).Text = StripPath(mdbfile$) & " repaired."
    End If
    Exit Sub

localErr:
    For Each errLoop In DBEngine.Errors
        MsgBox errLoop.Description, vbCritical, errLoop.Number
    Next
End Sub

Private Function StripPath(sPathFname As String)
    On Error GoTo localErr
    Dim pos%
    pos% = InStrRev(sPathFname, "\", -1, vbTextCompare)
    If pos% < Len(sPathFname) Then
        StripPath = Mid(sPathFname, pos% + 1, Len(sPathFname))
    End If
    Exit Function

localErr:
    MsgBox Err.Description, vbCritical, Err.Number
End Function

Private Sub Toolbar1_ButtonClick(ByVal Button As MSComctlLib.Button)
    On Error GoTo localErr
    Select Case Button.Key
        Case "compact"
            mnuFileCompact_Click
        Case "repair"
            mnuFileRepair_Click
    End Select
    Exit Sub

localErr:
    MsgBox Err.Description, vbCritical, Err.Number
End Sub

