Attribute VB_Name = "modcdhtmlexp"
Option Explicit
    'Copyright  2003 Chian
    'All rights reserved.
    Public Declare Function OSWinHelp% Lib "user32" Alias "WinHelpA" (ByVal hWnd&, ByVal HelpFile$, ByVal wCommand%, dwData As Any)
    Public Const HELP_CONTENTS = &H3
    Public Const HELP_KEY = &H101
    '
    Declare Sub GlobalMemoryStatus Lib "kernel32" (lpmstMemStat As MEMORYSTATUS)
    Type MEMORYSTATUS
        dwLength As Long    ' 32
        dwMemoryLoad As Long    ' percent of memory in use
        dwTotalPhys As Long ' bytes of physical memory
        dwAvailPhys As Long ' free physical memory bytes
        dwTotalPageFile As Long ' bytes of paging file
        dwAvailPageFile As Long ' free bytes of paging file
        dwTotalVirtual As Long  ' user bytes of address space
        dwAvailVirtual As Long  ' free user bytes
    End Type
    '
    Public Enum fsource
        FILELOCAL
        FILEREMOTE
    End Enum
    Public gFILESOURCE As fsource
    '
    Global Const gDEFDIRECTORY As String = "C:\My Documents"
    Global gcurrentdir$
    Global Const gFILTERIDXDEF As Integer = 3
    Global gfilteridx%
    Global Const gffilter$ = "Cascaded Style Sheets (*.css)|*.css" & _
        "|HTML Document (*.htm;*.html;*.htx;*.otm)|*.html;*.html;*.htx;*.otm" & _
        "|HTML Files (*.htm;*.html)|*.htm;*.html" & _
        "|Hypertext Templates (*htt)|*.htt" & _
        "|Log Text Files (*.log)|*.log" & _
        "|Preprocessed HTML (*.asa;*.asp;*.aspx;*.htx)|*.asa;*.asp;*.aspx;*.htx" & _
        "|Recover Text from Any File (*.*)|*.*" & _
        "|Script Files (*.js;*.vbs)|*.js;*.vbs" & _
        "|Text Files (*.txt)|*.txt" & _
        "|Work Files (*.inc)|*.inc"
    Public Const gCHIANURL As String = "http://www.chian.co.uk"
    Global gfilename$
    Public Const gTODSECT As String = "TOD"
    Public Const gTODKEY As String = "Show tips at startup"
    Public Const gLUSEDSECT As String = "last used"
    Public Const gLUSEDDIRKEY As String = "directory"
    Public Const gLUSEDFIKEY As String = "filter index"
    '
    Global Const gPATHSTBL As String = "fpath"
    Public gDb As Database
    Public gsDbnamePath As String
    
Public Function GetFileText(fpath$) As String
    Dim ffile%

    ffile% = FreeFile
    Screen.MousePointer = vbHourglass
    On Error Resume Next
    Open fpath$ For Input As #ffile%
    GetFileText = StrConv(InputB(LOF(ffile%), 1), vbUnicode)
    Close #ffile%
    
    If Err Then
        GoTo localErr
    End If
    Screen.MousePointer = vbDefault
    Exit Function

localErr:
    Close #ffile%
    Screen.MousePointer = vbDefault
    MsgBox Err.Description, vbCritical, Err.Number
End Function

Public Function GetKey(sSect As String, sKey As String) As String
    On Error GoTo localErr
    GetKey = GetSetting(App.title, sSect, sKey)
    Exit Function
    
localErr:
    MsgBox Err.Description, vbCritical, Err.Number
End Function

Public Sub SaveFile(fpath$, txt$)
    On Error GoTo localErr
    Dim ffile%
    
    On Error Resume Next
    Screen.MousePointer = vbHourglass
    ffile% = FreeFile
    'save text file format
    Open fpath$ For Output As #ffile%
    Print #ffile%, txt$
    Close #ffile%
    If Err Then
        GoTo localErr
    End If
    Screen.MousePointer = vbDefault
    Exit Sub

localErr:
    Screen.MousePointer = vbDefault
    Close #ffile%
    MsgBox Err.Description, vbCritical, Err.Number
End Sub

Sub Main()
    On Error GoTo localErr
    App.HelpFile = App.path & "\cdexplorer.hlp"
    frmSplashCDE.Show
    frmSplashCDE.Refresh
    Load frmMain
    frmSplashCDE.Timer1.Interval = 2000
    frmSplashCDE.Timer1.Enabled = True
    Exit Sub
    
localErr:
    MsgBox Err.Description, vbCritical, Err.Number
End Sub

Public Sub OpenDB(dbName As Database, sDBNpath As String)
    On Error GoTo localErr
    Set dbName = DBEngine.Workspaces(0).OpenDatabase(sDBNpath, False, False)
    Exit Sub

localErr:
    MsgBox Err.Description, vbCritical, Err.Number
End Sub
Public Sub SetKey(sSect As String, sKey As String, sVal As String)
    On Error GoTo localErr
    SaveSetting App.title, sSect, sKey, sVal
    Exit Sub
    
localErr:
    MsgBox Err.Description, vbCritical, Err.Number
End Sub



