VERSION 5.00
Begin VB.Form frmTOD 
   Caption         =   "Tip of the Day"
   ClientHeight    =   3315
   ClientLeft      =   2370
   ClientTop       =   2400
   ClientWidth     =   5415
   Icon            =   "frmTOD.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3315
   ScaleWidth      =   5415
   StartUpPosition =   1  'CenterOwner
   WhatsThisButton =   -1  'True
   WhatsThisHelp   =   -1  'True
   Begin VB.CheckBox chkLoadTipsAtStartup 
      Caption         =   "&Show Tips at Startup"
      Height          =   315
      HelpContextID   =   31
      Left            =   120
      TabIndex        =   1
      ToolTipText     =   "Check tick to show tips at startup or uncheck with no tick to not show tips at startup"
      Top             =   2940
      WhatsThisHelpID =   31
      Width           =   1935
   End
   Begin VB.PictureBox picTOD 
      BackColor       =   &H00FFFFFF&
      Height          =   2715
      HelpContextID   =   34
      Left            =   120
      Picture         =   "frmTOD.frx":014A
      ScaleHeight     =   2655
      ScaleWidth      =   5115
      TabIndex        =   0
      Top             =   120
      WhatsThisHelpID =   34
      Width           =   5175
      Begin VB.Label Label1 
         BackColor       =   &H00FFFFFF&
         Caption         =   "Did you know..."
         BeginProperty Font 
            Name            =   "Verdana"
            Size            =   8.25
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   255
         Left            =   540
         TabIndex        =   3
         Top             =   180
         Width           =   2655
      End
      Begin VB.Label lblTipText 
         BackColor       =   &H00FFFFFF&
         BeginProperty Font 
            Name            =   "Verdana"
            Size            =   8.25
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   1635
         Left            =   180
         TabIndex        =   2
         Top             =   840
         Width           =   4815
      End
   End
   Begin VB.Image imgNextTip 
      Height          =   345
      Left            =   3120
      Picture         =   "frmTOD.frx":0454
      ToolTipText     =   "Click here to show next tip of the day"
      Top             =   2940
      WhatsThisHelpID =   28
      Width           =   720
   End
   Begin VB.Image imgClose 
      Height          =   345
      Left            =   4560
      Picture         =   "frmTOD.frx":116A
      ToolTipText     =   "Close dialogue wiindow"
      Top             =   2940
      WhatsThisHelpID =   25
      Width           =   720
   End
End
Attribute VB_Name = "frmTOD"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
    'Copyright  2003 Chian
    'All rights reserved.
    Dim mcTips As New Collection ' The in-memory database of tips.
    Const msTODFILENAME = "tipofday.txt" ' Name of tips file
    Dim curtipidx& ' Index in collection of tip currently being displayed.

Private Sub DoNextTip()
    On Error GoTo localErr
    ' Select a tip at random.
    Randomize
    curtipidx& = Int((mcTips.Count * Rnd) + 1)
    'Or, you could cycle through the Tips
    'in order
    'curtipidx& = curtipidx& + 1
    'If mcTips.Count < curtipidx& Then
    'curtipidx& = 1
    'End If
    DisplayCurrentTip
    Exit Sub

localErr:
    MsgBox Err.Description, vbCritical, Err.Number
End Sub

Function LoadTips(sFile As String) As Boolean
    On Error GoTo localErr
    Dim nextip$   ' Each tip read in from file.
    Dim fileno%   ' Descriptor for file.
    
    ' Obtain the next free file descriptor.
    fileno% = FreeFile
    ' Make sure a file is specified.
    If sFile = "" Then
        LoadTips = False
        Exit Function
    End If
    ' Make sure the file exists before trying to open it.
    If Dir(sFile) = "" Then
        LoadTips = False
        Exit Function
    End If
    ' Read the collection from a text file.
    Open sFile For Input As fileno%
    While Not EOF(fileno%)
        Line Input #fileno%, nextip$
        mcTips.Add nextip$
    Wend
    Close fileno%
    ' Display a tip at random.
    DoNextTip
    LoadTips = True
    Exit Function

localErr:
    MsgBox Err.Description, vbCritical, Err.Number
End Function

Private Sub chkLoadTipsAtStartup_Click()
    On Error GoTo localErr
    ' save whether or not this form should be displayed at startup
    SetKey gTODSECT, gTODKEY, chkLoadTipsAtStartup.Value
    Exit Sub

localErr:
    MsgBox Err.Description, vbCritical, Err.Number
End Sub

Private Sub Form_Load()
    On Error GoTo localErr
    ' Set the checkbox
    If GetKey(gTODSECT, gTODKEY) = "" Then
        chkLoadTipsAtStartup.Value = 1
        SetKey gTODSECT, gTODKEY, "1"
    Else
        chkLoadTipsAtStartup.Value = GetKey(gTODSECT, gTODKEY)
    End If
    ' Read in the tips file and display
    ' a tip
    If LoadTips(App.path & "\" & msTODFILENAME) = False Then
        lblTipText.Caption = "An error has occured because the " & msTODFILENAME & " file was not found? " & _
        "You will need to Uninstall this Numerology program " & _
           "and then install it again to recover the " & msTODFILENAME & " file."
    End If
    Exit Sub

localErr:
    MsgBox Err.Description, vbCritical, Err.Number
End Sub

Public Sub DisplayCurrentTip()
    On Error GoTo localErr
    If mcTips.Count > 0 Then
        lblTipText.Caption = mcTips.Item(curtipidx&)
    End If
    Exit Sub

localErr:
    MsgBox Err.Description, vbCritical, Err.Number
End Sub

Private Sub imgClose_Click()
    On Error GoTo localErr
    Unload Me
    Exit Sub

localErr:
    MsgBox Err.Description, vbCritical, Err.Number
End Sub

Private Sub imgNextTip_Click()
    On Error GoTo localErr
    DoNextTip
    Exit Sub

localErr:
    MsgBox Err.Description, vbCritical, Err.Number
End Sub
